/*
Guard Frames

Original Programming by Fav
Originally from FavChars and Silverhorn
Used with permission.
*/

freeslot("S_PARRYFUCKER", "SPR2_GARD")
states[S_PARRYFUCKER] = {SPR_PLAY, SPR2_GARD, -1, nil, 0, 0, S_PARRYFUCKER}

//Battlemod Parry and Guard frames because using TRNS SUCKS.....
//Also hi Fav was here :D
addHook("PostThinkFrame", function()
	// First, check if this is Battlemod. p.guard is WAY too vague to use on a whim.
	if not CBW_Battle return end
	
	for p in players.iterate
		if p and p.mo and p.mo.valid 
		and (p.mo.skin == "gemma")
			// Lets set up some variables to juggle with.
			
			local parrytics = 22 -- Change this to determine how long you want to set the parry frame to show up.
			if p.favguardpose_parryframetimer == nil or p.favguardpose_parryframetimer == 0 then p.favguardpose_parryframetimer = parrytics end
			
			// -----------------------------------------------------------------------------
			if (p.guard == 1 or p.guard == -1) -- Regular guarding
				p.mo.state = S_PARRYFUCKER
				p.mo.frame = A
			elseif (p.guard == 2 and p.guardtics == 8) -- Parry detected!
				p.favguardpose_parryframetimer = $ - 1 -- Parry frame activator!
			end
			if p.mo.state == S_PARRYFUCKER and p.guard != 0 then p.mo.flags2 = $1 & ~MF2_DONTDRAW end -- prevents flashing from pw_flashing (NOT the invinciblity from it though)
			
			
			//Timer Time! This is for how long the parry frame is active before reverting to normal.
			if p.favguardpose_parryframetimer != 0 and p.favguardpose_parryframetimer < parrytics
				p.favguardpose_parryframetimer = $-1
				if p.panim == PA_WALK or p.panim == PA_IDLE -- On the ground and just parried? use your parry frame!
					p.mo.state = S_PARRYFUCKER
					p.mo.frame = B
				elseif p.favguardpose_parryframetimer < 1 and p.mo.state == S_PARRYFUCKER -- Revert to Stand state when the timer ends and you're still in your parry frame.
					p.mo.state = S_PLAY_STND
				end
			end
		end
	end	
end)